#!/bin/python3

import socket
import csv
import datetime
import os

def convert_temp(temp) -> float:
    return round(175.0*float(temp) / (2**16 - 1) - 45.0, 2)

def convert_hum(hum) -> float:
    return round(100.0*float(hum) / (2**16 - 1), 2)

if __name__ == "__main__":
    sock =socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    sock.bind(("", 4444))

    index = 0

    now = datetime.datetime.now()
    filename = f"sht30_{now.date()}_{now.hour}-{now.minute}-{now.second}.csv"
    os.chdir(os.path.dirname(os.path.abspath(__file__)))

    csv_file = open(filename, mode="w+")
    csv_writer = csv.writer(csv_file)
    csv_writer.writerow(['Temperature [°C]', 'Humidity [%]'])

    while True:
        data, addr = sock.recvfrom(127)
        data = data.decode("utf-8").split("\n")[0]

        data = data.split(";")
        temp = data[0].split(":")
        hum = data[1].split(":")

        temp_hex = int(temp[0], base=16)
        temp_int = temp[1]

        hum_hex = int(hum[0], base=16)
        hum_int = hum[1]
        

        print(f"IP addr: {addr}")
        print(f"Temperature [°C]: {convert_temp(temp_hex)}, Humidity [%]: {convert_hum(hum_hex)}" ) 

        csv_writer.writerow([convert_temp(temp_hex), convert_hum(hum_hex)])